;*******************
;* Power Intellect *
;*******************
#INCLUDE "P12C509A.INC"
;    PIC12C509A
	__config	_IntRC_OSC & _WDT_OFF & _CP_OFF & _MCLRE_OFF

; RAM raspred
Cnt1      EQU      08h
Cnt2      EQU      09h
Bdat      EQU      0Ah ; IGN - GPIO,3
Flags     EQU      0Bh ; 0-NC, 1-FirstOP, 2-PWRON, 3-SHDWN
MIG       EQU      0Ch ; 0-GrTemp, 1-SHDwn, 2-ON
Temp      EQU      0Dh
CntL      EQU      0Eh
CntH      EQU      0Fh
CntLED    EQU      19h
CMDPC     EQU      1Ah
Cnt3      EQU      1Bh
CRCSum    EQU      1Ch
Dat2      EQU      1Dh
; RAM raspred

; programm code
;          ORG      03FFh
;          movlw    0h
          ORG      0h
;          movwf    OSCCAL
          goto     START
;    480us
DEL480    movlw    19h
          movwf    Cnt1
DEL480_1  movlw    05h
          movwf    Cnt2
DEL480_2  decfsz   Cnt2,f
          goto     DEL480_2
          decfsz   Cnt1,f
          goto     DEL480_1
          retlw    00h
;    410us
DEL410    movlw    15h
          movwf    Cnt1
DEL410_1  movlw    05h
          movwf    Cnt2
DEL410_2  decfsz   Cnt2,f
          goto     DEL410_2
          decfsz   Cnt1,f
          goto     DEL410_1
          retlw    00h
;    100us
DEL70     movlw    16h
          movwf    Cnt1
DEL70_1   decfsz   Cnt1,f
          goto     DEL70_1
          retlw    00h
;   LED
Migan     incf     CntLED
          btfsc    MIG,0
          goto     MIG_GrT
          btfsc    MIG,1
          goto     MIG_SHD
          btfsc    MIG,2
          goto     MIG_ON
          clrf     CntLED
MIG_OFF   bcf      GPIO,4
          retlw    00h
MIG_GrT   movlw    02h
          goto     MIG_PR0
MIG_SHD   movlw    03h
MIG_PR0   subwf    CntLED,0
          movwf    Cnt1
          btfsc    Cnt1,7
          retlw    00h
          clrf     CntLED
          btfsc    GPIO,4
          goto     MIG_OFF
MIG_ON    bsf      GPIO,4
          retlw    00h

;     DS18B20
InitDS    movlw    0Ah ; GP5=OUT GP4=OUT GP3=IN GP2=OUT GP1=IN GP0=OUT
          tris     GPIO
          bcf      GPIO,2
          call     DEL480
          movlw    0Eh ; GP5=OUT GP4=OUT GP3=IN GP2=IN GP1=IN GP0=OUT
          tris     GPIO
          call     DEL70
          btfsc    GPIO,2
          retlw    01h
          call     DEL410
          retlw    00h
;     DS18B20
WrDS      movwf    Bdat
          movlw    0Ah ; GP5=OUT GP4=OUT GP3=IN GP2=OUT GP1=IN GP0=OUT
          tris     GPIO
          movlw    08h
          movwf    Cnt2
WrDS_01   rrf      Bdat,f
          bcf      GPIO,2
          nop
          btfsc    STATUS,0
          bsf      GPIO,2
          call     DEL70
          bsf      GPIO,2
WrDS_02   decfsz   Cnt2,f
          goto     WrDS_01
          retlw    00h
;     DS18B20
RdDS      movlw    10h
          movwf    FSR
          movlw    09h
          movwf    Cnt3
RdDS0     movlw    08h
          movwf    Cnt2
RdDS1     movlw    0Ah ; GP5=OUT GP4=OUT GP3=IN GP2=OUT GP1=IN GP0=OUT
          tris     GPIO
          bcf      GPIO,2
          nop
          movlw    0Eh ; GP5=OUT GP4=OUT GP3=IN GP2=IN GP1=IN GP0=OUT
          tris     GPIO
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          rrf      INDF,f
          bsf      INDF,7
          btfss    GPIO,2
          bcf      INDF,7
          call     DEL70
          decfsz   Cnt2
          goto     RdDS1
          incf     FSR,f
          decfsz   Cnt3
          goto     RdDS0
          retlw    00h
;   
START     movlw    40h
          option
          clrf     TMR0
          movlw    04h
          movwf    GPIO
          movlw    0Ah ; GP5=OUT GP4=OUT GP3=IN GP2=OUT GP1=IN GP0=OUT
          tris     GPIO
          clrf     Flags
          bsf      Flags,1
          clrf     CntLED
          clrf     MIG
;  "   T"
Prod00    btfss    GPIO,1
          goto     IBM_PC              
          call     Migan
          call     InitDS
          movwf    Cnt1
          btfsc    Cnt1,0
          goto     WWOT  ;    ,   T 
          movlw    0CCh
          call     WrDS
          movlw    044h
          call     WrDS
          movlw    0Eh ; GP5=OUT GP4=OUT GP3=IN GP2=IN GP1=IN GP0=OUT
          tris     GPIO
          nop
          movlw    4Ch
          movwf    Cnt1
          movlw    021h
          movwf    Cnt2
PA100     btfss    GPIO,1
          goto     IBM_PC              
          decfsz   Cnt2
          goto     PA100
          decfsz   Cnt1
          goto     PA100
Treq0     btfss    GPIO,2
          goto     Treq0
          bsf      Flags,1
          goto     Prod02
;  EEPROM   DS18B20
          call     InitDS
          movwf    Cnt1
          btfsc    Cnt1,0
          goto     WWOT  ;    ,   T 
          movlw    0CCh
          call     WrDS
          movlw    0B8h
          call     WrDS
          movlw    0Eh ; GP5=OUT GP4=OUT GP3=IN GP2=IN GP1=IN GP0=OUT
          tris     GPIO
Treq1     btfss    GPIO,2
          goto     Treq0
;  T
Prod02    call     InitDS
          movwf    Cnt1
          btfsc    Cnt1,0
          goto     WWOT  ;    ,   T 
          movlw    0CCh
          call     WrDS
          movlw    0BEh
          call     WrDS
          call     RdDS
          goto     CRCCal
ProdCRC   movlw    00h
          xorwf    CRCSum,0
          btfss    STATUS,2
          goto     Prod02
          bcf      Flags,1
          swapf    010h,0
          andlw    0fh
          movwf    Temp
          swapf    011h,0
          andlw    0f0h
          addwf    Temp,f
;  ? IGN=1?
          btfss    GPIO,3
          goto     IGN_OFF
;  ?
          movf     013h,0
          subwf    Temp,0
          movwf    Cnt1
          btfss    Cnt1,7
          goto     PWR_ON     ;  !
          bsf      MIG,0
          goto     Prod00
;  
PWR_ON    clrf     Flags
          bsf      Flags,2
          clrf     MIG
          bsf      MIG,2
          bsf      GPIO,5
          goto     Prod00
;   ? PWRON=1?
IGN_OFF   btfss    Flags,2
          goto     Prod00
;    ? SHDWN=1?
PWRON     btfss    Flags,3
          goto     SHDWN_OFF
          incf     CntL
          btfsc    STATUS,2
          incf     CntH
          movf     12h,0
          xorwf    CntH,0
          btfss    STATUS,2 ;    
          goto     Prod00
          bcf      Flags,2
          bcf      Flags,3
          clrf     MIG
          bcf      GPIO,5
          goto     Prod00
SHDWN_OFF bsf      MIG,1
          clrf     CntL
          clrf     CntH
          bsf      Flags,3
          goto     Prod00
;   DS18B20       
WWOT      movlw    01h
          movwf    12h
          movlw    4Bh
          movwf    Cnt1
          movlw    021h
          movwf    Cnt2
WWOT_1    btfss    GPIO,1
          goto     IBM_PC              
          decfsz   Cnt2
          goto     WWOT_1
          decfsz   Cnt1
          goto     WWOT_1
;  ? IGN=1?
          btfss    GPIO,3
          goto     IGN_OFF
          goto     PWR_ON
;    IBM-PC
IBM_PC    bsf      GPIO,0
PC2       call     InCMD
          btfsc    CMDPC,0
          goto     InBuf
          btfsc    CMDPC,1
          goto     OutBuf
          btfsc    CMDPC,2
          goto     WrEEPROM
PC0       btfss    GPIO,1
          goto     PC0
          goto     START

;     PC
InCMD     movlw    0Fh ; GP5=OUT GP4=OUT GP3=IN GP2=IN GP1=IN GP0=IN
          tris     GPIO
          movlw    08h
          movwf    Cnt1
InCMD_0   rrf      CMDPC,f
          bsf      CMDPC,7
InCMD_1   btfss    GPIO,1
          goto     InCMD_1
          btfss    GPIO,0
          bcf      CMDPC,7
InCMD_2   btfsc    GPIO,1
          goto     InCMD_2
          decfsz   Cnt1
          goto     InCMD_0
          retlw    00h

;     PC
InBuf     movlw    12h
          movwf    FSR
          movlw    02h
          movwf    Cnt1
InBuf_01  movlw    08h
          movwf    Cnt2
InBuf_0   rrf      INDF,f
          bsf      INDF,7
InBuf_1   btfss    GPIO,1
          goto     InBuf_1
          btfss    GPIO,0
          bcf      INDF,7
InBuf_2   btfsc    GPIO,1
          goto     InBuf_2
          decfsz   Cnt2
          goto     InBuf_0
          incf     FSR,f
          decfsz   Cnt1
          goto     InBuf_01
          goto     PC2

;     PC
OutBuf    movlw    0Eh ; GP5=OUT GP4=OUT GP3=IN GP2=IN GP1=IN GP0=OUT
          tris     GPIO
          movlw    10h
          movwf    FSR
          movlw    09h
          movwf    Cnt1
OutBuf_0  movf     INDF,0
          movwf    CMDPC
          movlw    08h
          movwf    Cnt2
OutBuf_1  btfss    GPIO,1
          goto     OutBuf_1
OutBuf_2  btfss    CMDPC,0
          goto     Put0
          bsf      GPIO,0
          goto     OutBuf_3
Put0      bcf      GPIO,0
OutBuf_3  btfsc    GPIO,1
          goto     OutBuf_3
          rrf      CMDPC,f
          decfsz   Cnt2
          goto     OutBuf_1
          incf     FSR,f
          decfsz   Cnt1
          goto     OutBuf_0
          goto     PC2
;     EEPROM DS18B20
WrEEPROM  movlw    0Eh ; GP5=OUT GP4=OUT GP3=IN GP2=IN GP1=IN GP0=OUT
          tris     GPIO
          bcf      GPIO,0
          call     InitDS
          movwf    Cnt1
          btfsc    Cnt1,0
          goto     IBM_PC  ;  T 
          movlw    0CCh
          call     WrDS
          movlw    04Eh
          call     WrDS
          movf     12h,0
          call     WrDS
          movf     13h,0
          call     WrDS
          movlw    01Fh
          call     WrDS

          call     InitDS
          movwf    Cnt1
          btfsc    Cnt1,0
          goto     IBM_PC  ;  T 
          movlw    0CCh
          call     WrDS
          movlw    048h
          call     WrDS
          movlw    0Eh ; GP5=OUT GP4=OUT GP3=IN GP2=IN GP1=IN GP0=OUT
          tris     GPIO
Wr_1      btfsc    GPIO,2
          goto     IBM_PC
          goto     Wr_1

;   CRC  DS18B20
CRCCal    movlw    10h
          movwf    FSR
          clrf     CRCSum
          movlw    09h
          movwf    Cnt1
CRC_0     movf     INDF,0
          movwf    Bdat
          movlw    08h
          movwf    Cnt2
CRC_1     movf     CRCSum,0
          xorwf    Bdat,0
          movwf    Dat2
          movf     CRCSum,0
          btfsc    Dat2,0
          xorlw    18h
          movwf    CRCSum
          bcf      STATUS,0
          btfsc    Dat2,0
          bsf      STATUS,0
          rrf      CRCSum,1
          bcf      STATUS,0
          btfsc    Bdat,0
          bsf      STATUS,0
          rrf      Bdat,1
          decfsz   Cnt2
          goto     CRC_1
          incf     FSR,1
          decfsz   Cnt1
          goto     CRC_0
          goto     ProdCRC
          end
